import { HttpBackend } from '@angular/common/http';
import { Observable } from 'rxjs';
import { LogPosition } from './types/log-position';
export declare class NGXMapperService {
    private httpBackend;
    private cache;
    private errorCache;
    constructor(httpBackend: HttpBackend);
    private static getStackLine();
    private static getPosition(stackLine);
    private static getTranspileLocation(stackLine);
    private static getMapFilePath(stackLine);
    private static getMapping(sourceMap, position);
    /**
     * does the http get request to get the source map
     * @param sourceMapLocation
     * @param distPosition
     */
    private _getSourceMap(sourceMapLocation, distPosition);
    /**
     * Returns the LogPosition for the current log
     * If sourceMaps are enabled, it attemps to get the source map from the server, and use that to parse the file name
     * and number of the call
     * @param sourceMapsEnabled
     */
    getCallerDetails(sourceMapsEnabled: boolean): Observable<LogPosition>;
}
